﻿Imports Windows.Devices.Enumeration
Imports Windows.Devices.HumanInterfaceDevice

Public Class cls_BlinkStick
    Public Class BlinkStick
        Public Info As DeviceInformation
        Public ID As String
    End Class

    Protected Const VendorId As Integer = &H20A0
    Protected Const ProductId As Integer = &H41E5


    Public Async Function FindAllAsync() As Task(Of BlinkStick())
        Dim result As New List(Of BlinkStick)()

        Dim selector As [String] = HidDevice.GetDeviceSelector(&HFF00, &H1, VendorId, ProductId)

        Dim deviceInformationList = Await DeviceInformation.FindAllAsync(selector)

        For Each info As DeviceInformation In deviceInformationList
            Dim led As New BlinkStick()
            led.Info = info
            led.ID = info.Id
            result.Add(led)
        Next

        Return result.ToArray()
    End Function

    Public Async Function FindFirstAsync() As Task(Of BlinkStick)
        Dim devices As BlinkStick() = Await FindAllAsync()

        Return If(devices.Length > 0, devices(0), Nothing)
    End Function

    Private Async Function OpenDeviceAsyncINTERN(ByVal DeviceID As String) As Task(Of Boolean)
        Dim theDevice As HidDevice

        theDevice = Await HidDevice.FromIdAsync(DeviceID, Windows.Storage.FileAccessMode.ReadWrite)

        'this.device = await HidDevice.FromIdAsync(@"\\?\HID#VID_20A0&PID_41E5#6&2413d1cd&0&0000#{4d1e55b2-f16f-11cf-88cb-001111000030}", Windows.Storage.FileAccessMode.ReadWrite);
        Dim connectedToDriver As Boolean = theDevice IsNot Nothing

        Return connectedToDriver
    End Function

    Public Async Function OpenDeviceAsync(ByVal DeviceID As String) As Task(Of Boolean)
        Dim result As Boolean = False

        result = Await OpenDeviceAsyncINTERN(DeviceID)
        Return result
    End Function
End Class
